=== debian/changelog ===
ros-galactic-openvslam (0.2.4-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- ymd-stella <world.applepie@gmail.com>  Sat, 25 Dec 2021 20:31:45 -0000
