=== debian/control ===
Source: ros-galactic-openvslam
Section: misc
Priority: optional
Maintainer: ymd-stella <world.applepie@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev, libgoogle-glog-dev, libopencv-dev, libyaml-cpp-dev, ros-galactic-libg2o, ros-galactic-ros-workspace
Homepage: https://openvslam-community.readthedocs.io/
Standards-Version: 3.9.2

Package: ros-galactic-openvslam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libgoogle-glog-dev, libopencv-dev, libyaml-cpp-dev, ros-galactic-libg2o, ros-galactic-ros-workspace
Description: OpenVSLAM: A Versatile Visual SLAM Framework
